package {
	
	
	import com.buraks.utils.fastmem;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Shader;
	import flash.display.Shape;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import flash.system.ApplicationDomain;
	import flash.text.TextField;
	import flash.utils.ByteArray;
	import com.flashdynamix.utils.SWFProfiler;
	
	public class Example extends MovieClip {
		
		private var byteArray:ByteArray;
		private var bData:BitmapData;
		private var countr:uint = 0;
		private var rect:Rectangle;
				
		private var color:uint;
		private var alph:uint;
		private var red:uint;
		private var green:uint;
		private var blue:uint;
		
		private var doBlue:int = 1;
		private var doRed:int = 0;
		private var doGreen:int = 1;
		
		private var prevTime:int;
		private var frameRate:int = 0;
		private var outputText:TextField;
		private var numBytes:int;
		
		
		public function Example() 
		{
			
			SWFProfiler.init(this.stage, this);
			
			[SWF(width="500", height="500", frameRate="120", backgroundColor="#ffffff")]
			
			byteArray = new ByteArray();
			byteArray.length = ApplicationDomain.MIN_DOMAIN_MEMORY_LENGTH;
			
			bData = new BitmapData(stage.stageWidth, stage.stageHeight, true);
			var bitmap:Bitmap = new Bitmap(bData);
			rect = new Rectangle(0, 0, stage.stageWidth, stage.stageHeight);
			numBytes =  stage.stageWidth * stage.stageHeight * 4; // total number of pixels multiplied by 4 = total number of bytes
			
			var pixels:ByteArray = bData.getPixels(rect);
			byteArray.position=0;
			pixels.position = 0;
			byteArray.writeBytes(pixels);
			
			red 	= 0x00 ;
			green 	= 0x00 ; 
			blue 	= 0x00 ; 
			
			addChild(bitmap); 
			
			stage.addEventListener("enterFrame", frameHandler);
			var s:Shape = new Shape();
			s.graphics.beginFill(0xFFFFFF);
			s.graphics.drawRect(0, stage.stageHeight-20, stage.stageWidth, 20);
			s.graphics.endFill();
			addChild(s);
			outputText = new TextField();
			outputText.width = stage.stageWidth;
			outputText.y = stage.stageHeight - 20;
			addChild(outputText);
			
		}
			
		private function frameHandler(e:Event) :void 
		{
			
			byteArray.position = 0; 					// prepare your ByteArray to be read from the start.
			fastmem.fastSelectMem(byteArray); 			// select your ByteArray with the fastmem.as class
			getColor(); 								// change the color 
			
			for (var i:int = 0; i < numBytes; i += 4)   // loop through all the memory addresses.												
			{
				fastmem.fastSetI32(color, i );			// write the 32bit unsigned interer holding the colour information
			}
		
			fastmem.fastDeselectMem(); 					// deselect the memory
			bData.setPixels(rect, byteArray);			// fill the Bitmap with the net BitmapData
			
			
		}
		
	
		private function getColor():void
		{		
			
			countr++; // change the looping of colours every 255 values
			
			blue += doBlue;
			green += doGreen;
			red += doRed;
			
			
			if (countr % 255 == 0) {
				
					if (blue == 0)	doBlue = Math.round(Math.random())
					if (red == 0)	doRed = Math.round(Math.random());
					if (green == 0)	doGreen = Math.round(Math.random());
						
					if (red == 255) 	doRed = -1 + Math.round(Math.random());
					if (blue == 255) 	doBlue =  -1 + Math.round(Math.random());
					if (green == 255) 	doGreen =  -1 + Math.round(Math.random());

			}
			
			outputText.text =  "  Red #" + red.toString(16).toUpperCase();
			outputText.appendText("  -  Green #" + green.toString(16).toUpperCase());
			outputText.appendText("  -  Blue #" + blue.toString(16).toUpperCase());
				
			alph = 0xFF 	
			color += blue; color = uint(color << 8);
			color += green; color = uint(color << 8);
			color += red; color = uint(color << 8);
			color += alph; 
			
		}
		
		
	}
}
